module Baud #
(
	parameter		BPS_PARA = 434			//50MʱӲʲѡ434Ӧ115200Ĳ
)
(
	input			clk,
	input			rst,
	input			bps_clk_en,
	output	reg		bps_clk
);

reg				[12:0]	cnt;

always @ (posedge clk or negedge rst) begin
	if (!rst)
		cnt <= 1'b0;
	else if((cnt >= BPS_PARA - 1) || (!bps_clk_en)) 
		cnt <= 1'b0;
	else
		cnt <= cnt + 1'b1;
end	

always @ (posedge clk or negedge rst) begin
		if (!rst)
			bps_clk <= 1'b0;
		else if (cnt == (BPS_PARA) >> 1)
			bps_clk <= 1'b1;
		else
			bps_clk <= 1'b0;
end
endmodule