module Uart_Bus #
(
parameter				BPS_PARA = 434 	//50MHzʱʱ434Ӧ115200Ĳ
)
(
input					clk,			//ϵͳʱ MHz
input					rst_n,			//ϵͳλЧ

output					clk_p,
output					clk_n,
				
input					d_clk,
input			[7:0]	data,

output					uart_tx			//UART
);

assign clk_p = clk;
assign clk_n = ~clk;
/*
reg [20:0] cnt1;
always @(posedge d_clk or negedge rst_n)
	if(!rst_n) cnt1 <= 1'b0;
	else cnt1 <= cnt1 + 1'b1;

reg [7:0] data_r;
always @(posedge d_clk or negedge rst_n)
	if(!rst_n) data_r <= 1'b0;
	else if(&cnt1) data_r <= data_r + 1'b1;
	else data_r <= data_r;

*/

reg [19:0] cnt;
always @(posedge clk or negedge rst_n)
	if(!rst_n) cnt <= 1'b0;
	else cnt <= cnt + 1'b1;
	
reg tx_data_valid;
reg [7:0] tx_data_in;
always @(posedge clk or negedge rst_n)
	if(!rst_n) begin
		tx_data_valid <= 1'b0;
		tx_data_in <= 8'b0;
	end else if(&cnt) begin
		tx_data_valid <= 1'b1;
		tx_data_in <= data;
		//tx_data_in <= tx_data_in + 1'b1;
	end else begin
		tx_data_valid <= 1'b0;
		tx_data_in <= tx_data_in;
	end

wire					bps_en_tx,bps_clk_tx;


//UARTͲʱӿģ 
Baud #
(
.BPS_PARA				(BPS_PARA		)
)
Baud_tx
(
.clk					(clk			),	//ϵͳʱ 50MHz
.rst_n					(rst_n			),	//ϵͳλЧ
.bps_en					(bps_en_tx		),	//ʱʹ
.bps_clk				(bps_clk_tx		)	//ʱ
);

//UARTģ 
Uart_Tx Uart_Tx_uut
(
.clk					(clk			),	//ϵͳʱ 50MHz
.rst_n					(rst_n			),	//ϵͳλЧ

.bps_en					(bps_en_tx		),	//ʱʹ
.bps_clk				(bps_clk_tx		),	//ʱ

.tx_data_valid			(tx_data_valid	),	//Ч
.tx_data_in				(tx_data_in		),	//Ҫ͵
.uart_tx				(uart_tx		)	//UART
);

endmodule