module Uart_Tx
(
	input				clk,
	input				rst,
	input				flag,		//ڷ
	output	reg			bps_clk_en,
	input				bps_clk,
	input		[7:0]	tx_data,
	output	reg			tx_PC,		//com
	output	reg			tx_done		//1֡ɱ־λ
);

reg			[3:0]		num;
reg			[9:0]		tx_data_r;

always @ (posedge clk or negedge rst) begin
	if(!rst) begin
		bps_clk_en <= 1'b0;
		tx_data_r <= 10'd0;
	end
	else if(flag) begin
		if(!bps_clk_en)
			begin
				bps_clk_en <= 1'b1;
				tx_data_r <= {1'b1, tx_data, 1'b0};
			end
		else if (num == 4'd10) begin
			bps_clk_en <= 1'b0;
		end else begin
			bps_clk_en <= bps_clk_en;
			tx_data_r <= tx_data_r;
		end 
	end else begin
		bps_clk_en <= 1'b0;
		tx_data_r <= tx_data_r;
	end
end

always @ (posedge clk or negedge rst) begin
	if (!rst) begin
		num <= 1'b0;
		tx_PC <= 1'b1;
		tx_done <= 1'b0;
	end
	else if (bps_clk_en) begin
		if (bps_clk) begin
			num <= num + 1'b1;
			tx_PC <= tx_data_r[num];
		end
		else if (num >= 4'd10) begin
			num <= 4'd0;
			tx_done <= 1'b1;
		end
		else tx_done <= 1'b0;
	end else tx_done <= 1'b0;
end
endmodule